#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);

	
	for (int i = 0; i < 1000; i++){
		particle myParticle;
		myParticle.setInitialCondition(ofRandom(0,1000),ofRandom(100,1000),0,0);
		// more interesting with diversity :)
		// uncomment this: 
		myParticle.damping = ofRandom(0.01, 0.05);
		particles.push_back(myParticle);
	}
	
}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
		counter=0;
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
		
	
		
	
		
		if(particles[i].pos.y>100)
		{
			
			particles[i].addAttractionForce(mouseX, mouseY, 1000, 0.0);
			//particles[i].addRepulsionForce(mouseX, mouseY, 60, 1);
			particles[i].addForce(0,0.05);  // gravity
		
		}
		
		if(particles[i].pos.y<100)
		{
			counter++;
		}
		
		
		
		//particles[i].addCounterClockwiseForce(mouseX, mouseY, 1000, 0.1);
		//particles[i].addClockwiseForce(mouseX, mouseY, 200, 1);
		
		
		particles[i].addDampingForce();
		particles[i].update();
	}

}

//--------------------------------------------------------------
void testApp::draw(){

	ofSetColor(0,0,0);
	ofDrawBitmapString("Particles Saved: " + ofToString(counter) + "/1000", 20, 20);
	
	ofSetColor(0x000000);
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].draw();
	}
	
	ofLine(0,100,ofGetWidth(),100);
	
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
		
		if(particles[i].pos.y>100)
		{
		particles[i].addAttractionForce(mouseX, mouseY, 500, 0.9);
		//particles[i].addRepulsionForce(mouseX, mouseY, 60, 1);
		}
		
		
		//particles[i].addCounterClockwiseForce(mouseX, mouseY, 1000, 0.1);
		//particles[i].addClockwiseForce(mouseX, mouseY, 200, 1);
		
		//particles[i].addForce(0,0.05);  // gravity
		particles[i].addDampingForce();
		particles[i].update();
	}
	
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
}
